package org.jeecg.modules.ctop.service;

import java.util.Map;

public interface IByteDanceAdvertiserDataService {
    Map<String, Object> getAdvertiserInfo(String accountId);

    Map<String, Object> getAdvertiserPlan(String accountId,String ids);

    Map<String, Object> getAdvertiserCampaign(String accountId,String ids);

    Map<String, Object> getAdvertiserBudget(String accountId);

    Map<String, Object> getAdvertiserCreative(String accountId,String ids);

    Map<String, Object> getAdvertiserCreativeMaterial(String accountId, String creativeIds);

    Map<String, Object> advertiserCampaignCreate(String accountId, String campaignName, String budgetMode, Integer budget, String landingType);

    Map<String, Object> advertiserCampaignUpdateStatus(String accountId, String campaignIds, String optStatus);

    Map<String, Object> advertiserCampaignUpdate(String accountId, Long campaignId, String budgetMode, Integer budget,String campaignName);

    Map<String, Object> advertiserPlanUpdateStatus(String accountId, String adIds, String optStatus);

    Map<String, Object> advertiserPlanUpdateBid(String accountId, String adIds, String bids);

    Map<String, Object> advertiserPlanUpdateBudget(String accountId, String adIds, String budgets);

    Map<String, Object> advertiserCreativeUpdateStatus(String accountId, String ids, String optStatus);

    Map<String, Object> advertiserCustomAudienceSelect(String accountId);
}
