package org.jeecg.modules.ctop.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.jeecg.common.api.vo.Result;
import org.jeecg.modules.ctop.entity.ByteDanceBudgetTemplate;
import com.baomidou.mybatisplus.extension.service.IService;
import org.jeecg.modules.ctop.entity.ByteDanceCampaignTemplate;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * @Description: 今日头条预算模板信息
 * @Author: jeecg-boot
 * @Date: 2019-07-22
 * @Version: V1.0
 */
public interface IByteDanceBudgetTemplateService extends IService<ByteDanceBudgetTemplate> {

    Map<String, Object> insertTemplate(ByteDanceBudgetTemplate template);

    Result<IPage<ByteDanceBudgetTemplate>> getList(ByteDanceBudgetTemplate template, Integer pageNo, Integer pageSize, HttpServletRequest req);
}
