package org.jeecg.modules.ctop.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.jeecg.common.api.vo.Result;
import org.jeecg.modules.ctop.entity.BytedanceDeliveryTargetTemplate;
import com.baomidou.mybatisplus.extension.service.IService;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * @Description: 投放目标模板信息
 * @Author: jeecg-boot
 * @Date: 2019-07-23
 * @Version: V1.0
 */
public interface IBytedanceDeliveryTargetTemplateService extends IService<BytedanceDeliveryTargetTemplate> {

    Map<String, Object> insertTemplate(BytedanceDeliveryTargetTemplate template);

    Result<IPage<BytedanceDeliveryTargetTemplate>> getList(BytedanceDeliveryTargetTemplate template, Integer pageNo, Integer pageSize, HttpServletRequest req);
}
