package cn.com.ctop.kuaishou.modules.app.service.impl;

import cn.com.ctop.kuaishou.modules.app.entity.AppAd;
import cn.com.ctop.kuaishou.modules.app.mapper.AppAdMapper;
import cn.com.ctop.kuaishou.modules.app.service.IAppAdService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AppAdServiceImpl extends ServiceImpl<AppAdMapper, AppAd> implements IAppAdService {
    @Autowired
    private AppAdMapper appAdMapper;

    public List<AppAd> queryAdFeeds(String userName, String industry, String company, String product, String start, String end, String orderByColumn, String orderByType, Integer pageStart, Integer pageSize) {
        return appAdMapper.queryAdFeeds(userName, industry, company, product, start, end, orderByColumn, orderByType, pageStart, pageSize);
    }
}
